import java.util.*;
import java.io.*;

/**
   Per gestire una Enumeration (di un array) serializzabile.
   Quello restituito da keys() del Vector NON e' serializzabile!!!
   (gli ho anche mandato una mail)
   Forse non servira' piu', se gli Iterator saranno serializzabili.
   @author Andrea Trentini
*/
public class ObjectArrayEnumerator implements Enumeration,Serializable
{
   /**
      @serial
   */
   Object[] array;

   /**
      cursore
      @serial
   */
   int cursor;

   /**
      aggiunge un'altra enumeration, crea un nuovo array (attenzione alle condivisioni)
   */
   public void append(ObjectArrayEnumerator e)
   {
      Object[] newarray=new Object[array.length+e.array.length];

      System.arraycopy(array,0,newarray,0,array.length);
      System.arraycopy(e.array,0,newarray,array.length,e.array.length);

      array=newarray;
   }

   public ObjectArrayEnumerator(Object[] arr)
   {
      array=arr;
      cursor=0;
   }

   public boolean hasMoreElements()
   {return cursor < array.length;}

   public Object nextElement()
   {
      synchronized (array)
      {
         if (cursor < array.length)
         {return array[cursor++];}
      }
      throw new NoSuchElementException("ObjectArrayEnumerator");
   }

   /**
      PUO' essere scorso piu' volte!!!
      <p>
      PERO' ATTENZIONE CHE RESETTA IL CURSORE!!!
   */
   public void reset()
   {
      cursor=0;
   }

   /**
      USARE CON ATTENZIONE!!!
      <p>
      RESETTA IL COUNTER!!!
   */
   public String toString()
   {
      StringBuffer tmp=new StringBuffer();

      reset();

      tmp.append(Html.OBEGIN);
      tmp.append(Html.instance(super.toString()));
      tmp.append("<tr><td>&nbsp;</td><td><ul>");
      while(hasMoreElements())
      {
         //tmp.append("<tr><td>");
         tmp.append("<li>");
         tmp.append(nextElement().toString());
         tmp.append("</li>");
         //tmp.append("</tr></td>");
      }
      tmp.append("</ul></tr></td>");
      tmp.append(Html.OEND);

      return tmp.toString();
   }

   /**
      testing...
   */
   public static void main(String arg[])
   {
      String[] s={"pippo","pluto","paperino"};
      ObjectArrayEnumerator o=new ObjectArrayEnumerator(s);
      System.out.println(o);
   }
}
