/**
   Un oggetto che fornisce uno stato (che lo rappresenta)
   e che puo' inizializzarsi prendendone uno,
   e' l'oggetto che genera il Memento (State).

   @author Andrea Trentini
*/
public interface PersistentI
{
   /**
      prende uno stato e si inizializza...
      @param s stato da "assorbire"
      @return true se successo
   */
   public boolean absorbState(StateI s);

   /**
      fornisce uno uno stato che lo rappresenta
      @return lo stato costruito
   */
   public StateI spawnState();
}
