import java.util.*;

/**
   Gestisce le istanze di State da salvare,
   e' il "CareTaker" del "Memento".
   L'accesso e' a CHIAVE.
   NON e' un container, nel senso che non ha niente in RAM
   (anche se in realta' dipende dall'implementazione)

   @author Andrea Trentini
*/
public interface StorageI
{
   /**
      Prende in carico uno stato.
      (pensare alle politiche di OVERWRITING)
      @param s StateI
      @return true se successo
   */
   public boolean saveState(StateI s);

   /**
      Recupera lo stato, dato un ID
      @return lo stato, null se non c'e'
   */
   public StateI retrieveState(String id);

   /**
      Rimuove uno stato dallo storage
   */
   public boolean deleteState(String id);

   /**
      Controlla se un ID e' presente
      @return true se c'e'
   */
   public boolean isIn(String id);

   /** Elenco delle chiavi */
   public Enumeration keys();
   // (1.2 ?) public ListIterator keys();

   /** Elenco delle chiavi FILTRATO */
   public Enumeration keys(String filter);
   //public ListIterator keys(String filter);

   /** Quanti sono? */
   public int count();
}
