import java.util.*;

/**
   OGGETTO PERSISTENTE
   <br>
   un implementazione esempio...
   solo per fare un po' di test

   @author Andrea Trentini
*/
public class TestPersistent implements PersistentI, SerialStateI
{
   /**
      @serial
   */
   protected String id;
   /**
      @serial
   */
   protected int numero;

   public void modify()
   {
      numero++;
   }

   public String toString()
   {
      return
         Html.OBEGIN+
         Html.instance(super.toString())+
         Html.field("id",id)+
         Html.field("numero",""+numero)+
         Html.OEND;
   }

   public TestPersistent(String id,int i)
   {
      this.id=id;
      numero=i;
   }

   public String getId()
   {
      return id;
   }

   public boolean absorbState(StateI s)
   {
      if(s instanceof TestPersistent)
      {
         TestPersistent t=(TestPersistent)s;
         id=t.id;
         numero=t.numero;
      }
      return true;
   }

   public boolean equals(Object o)
   {
      if(Debug.PRINT)
         System.out.println("Debug from "+this.getClass()+": "+o);

      if(o instanceof TestPersistent)
      {
         TestPersistent other=(TestPersistent) o;
         return (other.id.equals(id) && other.numero==numero);
      }
      else
         return false;
   }

   public StateI spawnState()
   {
      return this;
   }
}
