import java.util.*;

/**
   Un altro OGGETTO PERSISTENTE, stavolta genera una Properties.

   @author Andrea Trentini
*/
public class TestPersistentProp implements PersistentI, SerialStateI
{
   /**
      @serial
   */
   protected String id;
   /**
      @serial
   */
   protected int numero;

   public void modify()
   {
      numero--;
   }

   public String toString()
   {
      return
         Html.OBEGIN+
         Html.instance(super.toString())+
         Html.field("id",id)+
         Html.field("numero",""+numero)+
         Html.OEND;
   }

   public TestPersistentProp(String id,int i)
   {
      this.id=id;
      numero=i;
   }

   public String getId()
   {
      return id;
   }

   public boolean absorbState(StateI s)
   {
      if(s instanceof SerialProp)
      {
         SerialProp t=(SerialProp)s;

         id=t.getProperty("ID");
         numero=Integer.parseInt(t.getProperty("NUM"));
      }
      return true;
   }

   public StateI spawnState()
   {
      SerialProp s=new SerialProp(id);
      s.setProperty("ID",id);
      s.setProperty("NUM",""+numero);
      return s;
   }
}
